Package org.springframework.cglib.core

# Class ClassEmitter

java.lang.Object
org.springframework.asm.ClassVisitor
org.springframework.cglib.core.ClassTransformer
org.springframework.cglib.core.ClassEmitter

Direct Known Subclasses:
  `ClassEmitterTransformer`

public class ClassEmitter extends ClassTransformer

Author:
  Juozas Baliuka, Chris Nokleberg

## Field Summary

### Fields inherited from class org.springframework.asm.ClassVisitor

`api, cv`

## Constructor Summary

Constructors
Constructor
Description
`ClassEmitter()`
`ClassEmitter(ClassVisitor cv)`

## Method Summary

Modifier and Type
Method
Description
`void`
`begin_class(int version, int access, String className, Type superType, Type[] interfaces, String source)`
`CodeEmitter`
`begin_method(int access, Signature sig, Type[] exceptions)`
`CodeEmitter`
`begin_static()`
`void`
`declare_field(int access, String name, Type type, Object value)`
`void`
`end_class()`
`int`
`getAccess()`
`ClassInfo`
`getClassInfo()`
`Type`
`getClassType()`
`CodeEmitter`
`getStaticHook()`
`Type`
`getSuperType()`
`protected void`
`init()`
`void`
`setTarget(ClassVisitor cv)`
`void`
`visit(int version, int access, String name, String signature, String superName, String[] interfaces)`
Visits the header of the class.
`void`
`visitEnd()`
Visits the end of the class.
`FieldVisitor`
`visitField(int access, String name, String desc, String signature, Object value)`
Visits a field of the class.
`MethodVisitor`
`visitMethod(int access, String name, String desc, String signature, String[] exceptions)`
Visits a method of the class.

### Methods inherited from class org.springframework.asm.ClassVisitor

`getDelegate, visitAnnotation, visitAttribute, visitInnerClass, visitModule, visitNestHost, visitNestMember, visitOuterClass, visitPermittedSubclass, visitRecordComponent, visitSource, visitTypeAnnotation`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ClassEmitter

public ClassEmitter(ClassVisitor cv)

### ClassEmitter

public ClassEmitter()

## Method Details

### setTarget

public void setTarget(ClassVisitor cv)

Specified by:
  `setTarget` in class `ClassTransformer`

### getClassInfo

public ClassInfo getClassInfo()

### begin_class

public void begin_class(int version, int access, String className, Type superType, Type[] interfaces, String source)

### getStaticHook

public CodeEmitter getStaticHook()

### init

protected void init()

### getAccess

public int getAccess()

### getClassType

public Type getClassType()

### getSuperType

public Type getSuperType()

### end_class

public void end_class()

### begin_method

public CodeEmitter begin_method(int access, Signature sig, Type[] exceptions)

### begin_static

public CodeEmitter begin_static()

### declare_field

public void declare_field(int access, String name, Type type, Object value)

### visit

public void visit(int version, int access, String name, String signature, String superName, String[] interfaces)
Description copied from class: `ClassVisitor`
Visits the header of the class.

Overrides:
  `visit` in class `ClassVisitor`
Parameters:
  `version` - the class version. The minor version is stored in the 16 most significant bits, and the major version in the 16 least significant bits.
  `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated `Opcodes.ACC_DEPRECATED` or a record `Opcodes.ACC_RECORD`.
  `name` - the internal name of the class (see `Type.getInternalName()`).
  `signature` - the signature of this class. May be null if the class is not a generic one, and does not extend or implement generic classes or interfaces.
  `superName` - the internal of name of the super class (see `Type.getInternalName()`). For interfaces, the super class is `Object`. May be null, but only for the `Object` class.
  `interfaces` - the internal names of the class's interfaces (see `Type.getInternalName()`). May be null.

### visitEnd

public void visitEnd()
Description copied from class: `ClassVisitor`
Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.

Overrides:
  `visitEnd` in class `ClassVisitor`

### visitField

public FieldVisitor visitField(int access, String name, String desc, String signature, Object value)
Description copied from class: `ClassVisitor`
Visits a field of the class.

Overrides:
  `visitField` in class `ClassVisitor`
Parameters:
  `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
  `name` - the field's name.
  `desc` - the field's descriptor (see `Type`).
  `signature` - the field's signature. May be null if the field's type does not use generic types.
  `value` - the field's initial value. This parameter, which may be null if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
Returns:
  a visitor to visit field annotations and attributes, or null if this class visitor is not interested in visiting these annotations and attributes.

### visitMethod

public MethodVisitor visitMethod(int access, String name, String desc, String signature, String[] exceptions)
Description copied from class: `ClassVisitor`
Visits a method of the class. This method must return a new `MethodVisitor` instance (or null) each time it is called, i.e., it should not return a previously returned visitor.

Overrides:
  `visitMethod` in class `ClassVisitor`
Parameters:
  `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
  `name` - the method's name.
  `desc` - the method's descriptor (see `Type`).
  `signature` - the method's signature. May be null if the method parameters, return type and exceptions do not use generic types.
  `exceptions` - the internal names of the method's exception classes (see `Type.getInternalName()`). May be null.
Returns:
  an object to visit the byte code of the method, or null if this class visitor is not interested in visiting the code of this method.